/* lab7a.c */

#include <stdlib.h>
#include <stdio.h>
#include <pthread.h>
#include <semaphore.h>

#define I_MAX_THREADS   254
#define I_MAX_PAGINAS   100
#define SZ_FORMATO      "Formato: p <#threads> <#paginas>\n"
#define SZ_MAX_THREADS  "O maximo de threads permitido e' %d\n"
#define SZ_MAX_PAGINAS  "O maximo de paginas permitido e' %d\n"
#define SZ_POS_PAGINAS  "O total de paginas deve ser positivo\n"
#define SZ_ERRO_CRIA    "Erro na criacao do thread %d\n"
#define SZ_NUM_THREADS  "Numero de threads %d\n"
#define SZ_TOT_PAGINAS  "Total de paginas %d\n"
#define SZ_PEDINDO      "Processo %d pedindo %d pginas\n"
#define SZ_CONSEGUE     "Processo %d conseguiu alocar %d pginas\n"
#define SZ_LIBERA       "Processo %d liberou %d pginas\n"


struct tgPares {
   int iNumPaginas ,
       iIdThread   ;
} ;

typedef struct tgPares Pairs[ I_MAX_THREADS ] ;


int   n                  ,
      iTotPaginas        ,
      iMaxPaginas        ,
      iNumPares          ;
sem_t e                  ,
      b[ I_MAX_THREADS ] ;
Pairs pairs              ;


void* UsarPaginas( void* MeuId ) ;

void request( int amount ,
              int iMeuId  ) ;

void release( int amount ,
              int iMeuId  ) ;

void Sinalizar( void ) ;

void InserirPar( int iNumPaginas ,
                 int iMeuId       ) ;

int iRemoverPar( void ) ;

void Esperar( int iMeuId ) ;


void* UsarPaginas( void* MeuId ) {
   int iNumPaginas                  ,
       iMeuId      = *( int* )MeuId ;

   srand( time( NULL ) * ( iMeuId + 1 ) ) ;

   while ( 1 ) {
      iNumPaginas = 1 + ( int )( ( ( double )iMaxPaginas * rand( ) )
                               / ( RAND_MAX + 1.0 ) ) ;

      printf( SZ_PEDINDO, iMeuId, iNumPaginas ) ;
      request( iNumPaginas, iMeuId ) ;
      Esperar( iMeuId ) ;
      release( iNumPaginas / 2, iMeuId ) ;
      iNumPaginas -= iNumPaginas / 2 ;
      Esperar( iMeuId ) ;
      release( iNumPaginas, iMeuId ) ;
   } /* while */
} /* UsarPaginas */


void request( int amount ,
              int iMeuId  ) {

   sem_wait( &e ) ;
   
   if ( amount > iTotPaginas ) {
      InserirPar( amount, iMeuId ) ;
      sem_post( &e ) ;
      sem_wait( &b[ iMeuId ] ) ;
   } /* if */

   iTotPaginas -= amount ;
   printf( SZ_CONSEGUE, iMeuId, amount ) ;
   Sinalizar( ) ;

} /* request */


void release( int amount ,
              int iMeuId  ) {

   sem_wait( &e ) ;
   iTotPaginas += amount ;
   printf( SZ_LIBERA, iMeuId, amount ) ;
   Sinalizar( ) ;

} /* release */


void Sinalizar( void ) {
   int iEscolhido = iRemoverPar( ) ;

   if ( iEscolhido >= 0 ) {
      sem_post( &b[ iEscolhido ] ) ;
   } else {
      sem_post( &e ) ;
   } /* if */
} /* Sinalizar */


void InserirPar( int iNumPaginas ,
                 int iMeuId       ) {

   pairs[ iNumPares ].iNumPaginas = iNumPaginas ;
   pairs[ iNumPares ].iIdThread = iMeuId ;
   iNumPares++ ;

} /* InserirPar */


int iRemoverPar( void ) {
   int i                                    ,
       iPrimeiro   = 0                      ,
       iIdPrimeiro = pairs[ 0 ].iIdThread   ,
       iMinPaginas = pairs[ 0 ].iNumPaginas ;

   for ( i = 1 ; i < iNumPares ; i++ ) {
      if ( pairs[ i ].iNumPaginas < iMinPaginas ) {
         iPrimeiro = i ;
         iIdPrimeiro = pairs[ i ].iIdThread ;
         iMinPaginas = pairs[ i ].iNumPaginas ;
      } /* if */
   } /* for */

   if ( iNumPares > 0 
     && iMinPaginas <= iTotPaginas ) {
      for ( i = iPrimeiro ; i < iNumPares - 1 ; i++ ) {
         pairs[ i ].iNumPaginas = pairs[ i + 1 ].iNumPaginas ;
         pairs[ i ].iIdThread = pairs[ i + 1 ].iIdThread ;
      } /* for */

      iNumPares-- ;
      return iIdPrimeiro ;
   } /* if */

   return -1 ;
} /* iRemoverPar */


void Esperar( int iMeuId ) {
   unsigned long int i                                        ,
                     lTotal = ( unsigned long )10000000L 
                            * ( unsigned long )( iMeuId + 1 ) ;

   for ( i = 0 ; i < lTotal ; i++ ) { }
} /* Esperar */


int main( int   argc    ,
          char* argv[ ]  ) {
   int       i                       ,
             iErro                   ;
   int*      pMeuId                  ;
   pthread_t Thread[ I_MAX_THREADS ] ;

   if ( argc != 3 ) {
      printf( SZ_FORMATO ) ;
      return 0 ;
   } /* if */

   n = atoi( argv[ 1 ] ) ;
   iTotPaginas = atoi( argv[ 2 ] ) ;

   if ( n > I_MAX_THREADS ) {
      printf( SZ_MAX_THREADS, I_MAX_THREADS ) ;
      return 0 ;
   } /* if */

   if ( iTotPaginas > I_MAX_PAGINAS ) {
      printf( SZ_MAX_PAGINAS, I_MAX_PAGINAS ) ;
      return 0 ;
   } /* if */

   if ( iTotPaginas <= 0 ) {
      printf( SZ_POS_PAGINAS ) ;
      return 0 ;
   } /* if */

   iNumPares = 0 ;
   iMaxPaginas = iTotPaginas ;

   printf( SZ_NUM_THREADS, n ) ;
   printf( SZ_TOT_PAGINAS, iTotPaginas ) ;

   sem_init( &e, 0, 1 ) ;
   for ( i = 0 ; i < n ; i++ ) {
      sem_init( &b[ i ], 0, 0 ) ;
   } /* for */

   for ( i = 0 ; i < n ; i++ ) {
      pMeuId = ( int* )malloc( sizeof( int ) ) ;
      *pMeuId = i ;

      iErro = pthread_create( &Thread[ i ], NULL, UsarPaginas,
                                                  ( void* )( pMeuId ) ) ;

      if ( iErro != 0 ) {
         printf( SZ_ERRO_CRIA, i ) ;
         return 1 ;
      } /* if */
   } /* for */

   pthread_exit( NULL ) ;

   return 0 ;
}
